clear;
clc;

S = create_trellis(4);
N = 1024;
% number of times to simulate each Eb/N0 value
sim_per_db = 10;
% maximum iterations for turbo decoder
max_iter = 10;
% 1 to 3 dB by 0.5 dB (6 data points)
EbN0vec = 1:.5:3;
% initialize ber array
ber = zeros(length(EbN0vec),max_iter+1);

for ii=1:length(EbN0vec)
    trial_ber=0;
    fprintf('Eb/N0=%g dB Trial 1\n',EbN0vec(ii));
    for jj=1:sim_per_db
        if mod(jj,20)==0
            fprintf('Eb/N0=%g dB Trial %d\n',EbN0vec(ii),jj);
        end
        res = turbo_trial(EbN0vec(ii),N,max_iter,S);
        trial_ber=trial_ber+res;
    end
    trial_ber=trial_ber/sim_per_db;
    ber(ii,:) = trial_ber;
end

% save the important stuff and ensure we do not overwrite something
% important
save(['bf-' datestr(clock,30)],'EbN0vec','ber','N','sim_per_db','max_iter','S');