function [yk sp] = rsc(dk,s);
% implements RSC from Berrou, Glavieux, Thitimajshima
% dk is input bit
% state is a number from 0-15
% yk is output parity bit
% state is new state

state = binvec(s);

ak = mod(dk+sum(state),2);
yk = mod(ak+state(4),2);
state(2:end) = state(1:end-1);
state(1) = ak;
sp = bin2dec(char(state(end:-1:1)+48));
end

function ans = binvec(num)
ans = double(dec2bin(num,4)-48);
ans = ans(end:-1:1);
end